;
; function.asm - Function key handler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

functionkeys	.proc
                lda $d3		;X
                sta $ca
                lda $d6		;Y
                sta $c9
                #phy_a
                #phx_a
                lda $d0
                beq ss
                #psr $e63a
exit            jmp exit2basic

ll              jsr $e716

ss		lda $c6
		bne kfk
                sta $cc
                ldx #5
ir              lda keywait,x
                sta $267,x
                lda ps,x
                pha
                dex
                bpl ir
                gmi exit

loadrun         ldx #9
                stx $c6
ru              lda loadtxt-1,x
                sta $277-1,x
                dex
                bne ru

kfk		sta $cc
                sta $0292
                sei
                #sta_cfg_16
                lda $cf
                beq kk
                #stz_a $cf
                lda $ce
                ldx $0287
                jsr $ea13
kk              jsr $e5b4
                cmp #$83
                beq loadrun

		ldx $d4    	;Quote mode
                bne jdx
                ldx $d8		;Insert mode
jdx             bne jd
                bit msgmode    	;Program mode
                bpl jd

                cmp #4
                bne noctrld
                lda #24
                sta ActualFilename
re              dec ActualFilename
		beq nincs
		#lda0
                sta ActualFNLength
                adc ActualDev
                cmp #31
                bcs vv
                cmp #8
                bcs *+4
vv              lda #8
                sta ActualDev
                lda #$6f
                sta ActualSecAddr
                sta ActualLogical
                jsr newopen_t
                ldx ActualSecAddr
                jsr newchkout_t
                php
                jsr newclrchn_t
                lda ActualSecAddr
                jsr newclose_t
                plp
                bcs re
                ldx #$ff
                lda ActualDev
                sec
id              inx
                sbc #10
                bcs id
                adc #$3a
                pha
                txa
                beq kfs
                ora #$30
                jsr $e716
kfs             pla
                jsr $e716
nincs           lda #13
                gne ll

noctrld		pha
		sec
		sbc #$85
                cmp #8
                tay
                pla
		bcs jd

uru             #sta_cfg_open
		lda function_keys_exp,x
                #sta_cfg_16
                beq kf
		cmp #13
                beq kf
                cpy #0
                bne kf2
                jsr $e716
                iny
kf              dey
		bmi jd
kf2		inx
                bpl uru

jd		cmp #13
		bne ll
                #psr $e602
		gcs exit

ps              .word $267-1
                .word switch_16k-1
                .word kfk-1

loadtxt		.text "load",13,"run",13

keywait		lda $c6
		beq *-2
                rts
                .pend
