;
; selftest.asm - Selftesting
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

self_zeropage	= 2
self_memtest	= 6

selftest	.proc
		sta cfg_8

                sta scpu_hwenable
                sta scpu_nooptim
                sta scpu_hwdisable

		lda #11
		sta $d011
		lda #self_zeropage
		sta $d020

		ldy #255
lp2		ldx #2
		sty $d000
		iny
		beq vvu
                dey

nni4		lda testpattern,y
		bne *+4
		ldy #255
		iny
		eor $00,x
		beq vvu
		lda $d000
		bpl *

vvu		lda testpattern,y
		sta $00,x
		inx
		bne nni4
		ldy $d000
		iny
		cpy #19
		bne lp2

		lda #self_memtest
		sta $d020
		sta $d021

		ldy #0
dp		sta $d800,y
		sta $d900,y
		sta $da00,y
		sta $db00,y
		iny
		bne dp

		ldx #(mtestend-mtest)
dp3		lda mtest-1,x
		sta $28-1,x
                cpx #8
                bcs ca
                lda #1
		sta $d828-1,x		
ca		dex
		bne dp3

		lda #200
		sta $d016
		stx $dd02
		stx $d015
		stx $d418
		lda #$fc
		sta $d030		;C128
		.if (SECOND_SID >> 8)=$d6
		lda $d030		;C128?
		lsr
		bcc *+5
		.fi
		stx SECOND_SID+$18	;Second SID
		lda #6
		sta $d018
		lda #27
		sta $d011
		sei
		lda #$37
		sta $01
		lda #$2f
		sta $00
		jmp $2f

mtestback	bcs memok

		lda #"!"
		sta $2d
		inc $d82d
		jmp *-3
memok
		lda #32
		ldx #0
ip		sta $400,x
		sta $500,x
		inx
		bne ip

		ldx #7
li		lda $28-1,x
		sta $428-1,x
		dex
		bne li

		lda #22
		sta $d018

		lda #1
ip2		sta $d800,x
		sta $d900,x
		inx
		bne ip2

		lda #122
		sta $42d

		ldx #7
li1a		lda de60txt,x
		sta $450,x
		dex
		bpl li1a

		ldx #$60
dtp		lda $9e00,x
		cmp $de00,x
		beq ti

		lda #"!"
		sta $456
		inc $d856
		jmp *-3

ti		inx
		bne dtp

		lda #122
		sta $456

		bit $d0bc
		bpl scpuskip

		ldx #9
li4		lda extramtxt,x
		sta $478,x
		dex
		bpl li4

		sta cfg_open
llp		lda $480
		tax
		asl
		jsr extramtest
		bcs merror2
		inc $480
		lda $480
		cmp #19
		bcc llp
		gcs oo

merror2		lda #"!"
		sta $480
		inc $d8d0
		jmp *-3

oo		lda #122
		sta $480

scpuskip	sta cfg_16

		ldx #9
li5		lda extromtxt,x
		sta $4a0,x
		dex
		bpl li5

re		jsr romtest
		beq kc2

		ldy #"!"
		sty $4a8
		inc $d8f8
		jmp *-3

kc2		dec $4a8
		bne re

		lda #122
		sta $4a8

		ldx #9
li7		lda nvramtxt-1,x
		sta $4c8-1,x
		dex
		bne li7
                stx kill_port

		lda #%11111111		;read ram burst command
		jsr cmos_start
                ldx #31
kb2             jsr cmos_read_byte	;read byte from RAM
		sta $27,x		;backup
                dex
                bne kb2
                stx kill_port

		lda #0
		sta $3
                clc
                jsr cmos_wp

lp3		lda #31
		sta $2
		lda #%11111110		;data write brust
		jsr cmos_start
		ldx $3
lp2j		lda testpattern,x
		bne *+4
		ldx #255
		inx
		jsr cmos_send_byte
		dec $2
		bne lp2j
		ldx #$00		;reset
		stx kill_port

		lda #31
		sta $2
		lda #%11111111		;read ram burst command
		jsr cmos_start
		ldx $3
lp		jsr cmos_read_byte	;read byte from RAM
		cmp testpattern,x
		beq tk
		ldx #0
		stx kill_port
		geq er

tk		lda testpattern,x
		bne *+4
		ldx #255
		inx
		dec $2
		bne lp
		ldx #$00		;reset
		stx kill_port

		inc $3
		lda $3
		cmp #19
		bcc lp3

		lda #122
		.byte $2c
er		lda #"!"
		sta $4cf

		lda #%11111110		;write ram burst command
		jsr cmos_start
                ldx #31
kb              lda $27,x		;backup
                jsr cmos_send_byte
		dex
                bne kb
                stx kill_port

		ldx #8
li8		lda clocktxt,x
		sta $4f0,x
		dex
		bpl li8

		jsr cmos_readsec
                and #$7f
                sta $28
                
                lda #%10000000
                jsr cmos_start
                lda $28
                jsr cmos_send_byte
                sta kill_port
                sec
                jsr cmos_wp

dr              bit $d011
                bpl *-3
                bit $d011
                bmi *-3
                dec $4f7
                bne dr

		jsr cmos_readsec
                eor $28
                beq er2

		lda #122
		.byte $2c
er2     	lda #"!"
		sta $4f7

		ldy #7
li9     	lda de32txt,y
		sta $518,y
		dey
		bpl li9

		ldx #de32tstend-de32tst
mv              lda de32tst-1,x
                sta $01,x
                dex
                bne mv
                
                ldy #3
                jsr $2
                bcs er3

		lda #122
		.byte $2c
er3	   	lda #"!"
		sta $51e

		ldx #7
li10		lda killtxt,x
		sta $540,x
		dex
		bpl li10

		ldx #killtstend-killtst
mv2             lda killtst-1,x
                sta $01,x
                dex
                bne mv2
                
                ldx #$60
nv              lda $9e00,x
                sta $00,x
                inx
                bne nv

		ldx #$60
                lda #1
		jmp $2

;------------------------
killtst
		.logical $2
                sta kill_port
kmd		lda $00,x
                cmp $de00,x
                bne gc
                inx
                bne kmd
		geq er4
gc		ldx #$60
kmd2		lda $00,x
                cmp $9e00,x
                bne gc2
                inx
                bne kmd2

er4		lda #"!"
		.byte $2c
gc2	   	lda #122
		sta $546

                jmp *
		.here
killtstend
;------------------------
de32tst
		.logical $2
js		sta bank_port0,y
		ldx #3
js2		sta cfg_16,x
		tya
                asl
                asl
		eor $de32
                and #$0f
                eor de32const,x
                beq *+3
                sec
                dex
                bpl js2
                dey
                bpl js
                rts

de32const	.byte $00,$02,$01,$03
		.here
de32tstend
;------------------------
cmos_wp		php
		lda #%10001110  	;disable write protect
		jsr cmos_start
                plp
                ror
                jsr cmos_send_byte
                sta kill_port
                rts

cmos_start	ldx #$02
		stx kill_port		;UNreset
cmos_send_byte	jsr *+3
		jsr *+3
		jsr *+3
		sta clock_port		; bit 0
		lsr a
		rts

cmos_read_byte	jsr *+3
		jsr *+3
		jsr *+3
		lda clock_port		; bit 1
		lsr a
		tya
		ror a
		tay
		rts

cmos_readsec   	lda #%10000001  	;read clock burst command
cmos_read      	jsr cmos_start
                jsr cmos_read_byte
                ldx #0
                stx kill_port
                rts
;------------------------

		.enc screen
de60txt		.text "DE60 [",32,"]"
extramtxt	.text "EXTRAM [",255,"]"
extromtxt	.text "EXTROM [",20,"]"
nvramtxt	.text "NVRAM [",32,"]"
clocktxt	.text "CLOCK [",70,"]"
de32txt		.text "DE32 [",32,"]"
killtxt		.text "KILL [",32,"]"
		.enc none

mtest		.logical $28

		.enc screen
		.text "RAM [",255,"]"
                .enc none

		inc $01
lpp		inc at+2
		inc at2+2
		ldx $2d
		bpl nni2
		inx
		geq vv

nl		ldx #0
		geq atv

nni2		lda testpattern2,x
		bne *+4
                ldx #255
		inx
at		eor $0000,y
at3		.byte $a9,merror-vv
vv		lda testpattern2,x
at2		sta $0000,y
		beq nl
                inx
atv		iny
		bne at
		inc at+2
		inc at2+2
		bne at
		lda #$d0		;bne
		sta at3

		inc $2d
		lda $2d
		cmp #19
		bcc lpp
		.byte $a9
merror		clc
		dec $01
mb		jmp mtestback

testpattern2
		.here

testpattern	.byte %10000000		;1
		.byte %01000000		;2
		.byte %00100000		;3
		.byte %00010000		;4
		.byte %00001000		;5
		.byte %00000100		;6
		.byte %00000010		;7
		.byte %00000001		;8
		.byte %11111111		;9
		.byte %01111111		;10
		.byte %10111111		;11
		.byte %11011111		;12
		.byte %11101111		;13
		.byte %11110111		;14
		.byte %11111011		;15
		.byte %11111101		;16
		.byte %11111110		;17
		.byte %01010101		;18
		.byte %00000000		;19
		.pend
mtestend

cable_pattern  	.byte 0,0,0,0,255,255,255,255,0,255,0,255,255,0

romtest		.proc
		ldx #rtestend-rtest
dg		lda rtest-1,x
		sta $101-1,x
		dex
		bne dg

		clc
		txa
		jsr $101
                
                sec
		sbc chksum
		bcs *+4
		dex
                sec
		sbc chksum+1
		bcs *+3
                dex

		cmp chksum
		bne kc
		cpx chksum+1
kc		rts

rtest		.logical $101
bnk		sta bank_port3
		ldy #$80
		sty icr+2
		sty hb2+2
lp		ldy #0
icr		adc $8000,y
		bcc hb2
                clc
		inx
hb2		adc $8080,y
		bcc hb
                clc
		inx
hb		iny
		bpl icr
		inc icr+2
		inc hb2+2
		bit icr+2
		bvc lp
		dec bnk+1
		dec k
		bne bnk
		rts
k               .byte 4
		.here
rtestend

		.pend

extramtest	.proc
		ldy #rtestend-rtest
dg		lda rtest-1,y
		sta $101-1,y
		dey
		bne dg

		lda #$10
		sta u+2
		sta uu+2
                jmp $101

rtest		.logical $101
		bcc nni
                lda #$f4
                sta at+1
		inx
		geq vv2

nl2		ldx #0
		geq u2

nni		lda selftest.testpattern,x
		bne *+4
                ldx #255
		inx
u		eor $ff00,y
	        bne merror2
vv2		lda selftest.testpattern,x
uu		sta $ff00,y
                beq nl2
                inx
u2		iny
at		bne u
		inc $d020
                dec $d020
		inc u+2
		inc uu+2
		bpl u
                clc
                rts
merror2		bcs vv2
		sec
                rts
                .here
rtestend
		.pend

transfer_test   .proc
		#stz_a pom1

test            jsr OP_get_current_drive_type
		beq ok		;no drive
                bmi ok		;non ata

                lda #write_buffer_d
		ldy #1
                jsr ata_data_commandany
                bcs err2
                ldy #0
                ldx pom1
kd              lda cable_pattern-19,x
		sta low_reg
                lda cable_pattern-19+1,x
                sta hig_reg
                sta data_g
                lda cable_pattern-19+2,x
		sta low_reg
                lda cable_pattern-19+3,x
                sta hig_reg
                sta data_g
                iny
                bpl kd
                jsr ata_pi_nomore_data
                bcs err

		lda #read_buffer_d
                ldy #1
                jsr ata_data_commandany
                bcs err2
                ldy #0
                ldx pom1
kd2             lda data_g
		#lda_low_reg
                eor cable_pattern-19,x
                bne kk
                lda hig_reg
                eor cable_pattern-19+1,x
                beq *+3
kk              sec
                lda data_g
		#lda_low_reg
                eor cable_pattern-19+2,x
                bne kkk
                lda hig_reg
                eor cable_pattern-19+3,x
                beq *+3
kkk		sec
		iny
                bpl kd2
                bcs err
                jsr ata_pi_nomore_data
                bcs err
		inc pom1
                lda pom1
                cmp #11+19
                bcc test
ok              clc
		rts

err2		lda pom1
		beq ok
err		lda #76+$80
		gne seterrorpos

		.pend
